/*==============================================================================
Locale Kit Sample Code
地域設定にダイナミックに追随するサンプル for Zeta R1 RC1 + Service Pack 1
by ＳＨＩＮＴＡ
==============================================================================*/

//------------------------------------------------------------------------------
#include "LocaleChangeSample.h"
//------------------------------------------------------------------------------
// BeOS Headers
#include <Locale.h>
#include <MenuItem.h>
#include <Messenger.h>
//==============================================================================
TLocaleApp::TLocaleApp()
		: SUPER("application/x-vnd.Sample-LocaleChangeSample")
{
	TLocaleWin*	aWin;

	aWin = new TLocaleWin(BRect(100, 100, 450, 200));
	aWin->Show();
}
//------------------------------------------------------------------------------
TLocaleApp::~TLocaleApp()
{
}
//==============================================================================
TLocaleWin::TLocaleWin(BRect oFrame)
		: SUPER(oFrame, "", B_TITLED_WINDOW, 0)
{
	SetWinTitle();
	// メニューバー構築
	mMBar = new BMenuBar(BRect(0, 0, 0, 0), "MenuBar");
	AddChild(mMBar);
	CreateMenu();
}
//------------------------------------------------------------------------------
TLocaleWin::~TLocaleWin()
{
}
//------------------------------------------------------------------------------
void	TLocaleWin::CreateMenu()
{
	BMenu*			aMenu;
	BMenuItem*		aMItem;

	// ファイルメニュー（システム辞書で日本語化）
	aMenu = new BMenu(_T("File"));
		aMItem = new BMenuItem(_T("Quit"), new BMessage(B_QUIT_REQUESTED));
		aMenu->AddItem(aMItem);
	mMBar->AddItem(aMenu);
	// サンプルメニュー（アプリケーション辞書で日本語化）
	aMenu = new BMenu(_T("Sample Menu"));
		aMItem = new BMenuItem(_T("Sample Menu Item"), NULL);
		aMenu->AddItem(aMItem);
	mMBar->AddItem(aMenu);
	// ヘルプメニュー（システム辞書で日本語化）
	aMenu = new BMenu(_T("Help"));
		aMItem = new BMenuItem(_T("About..."), new BMessage(B_ABOUT_REQUESTED));
		aMItem->SetTarget(be_app);
		aMenu->AddItem(aMItem);
	mMBar->AddItem(aMenu);
}
//------------------------------------------------------------------------------
void	TLocaleWin::DestroyMenu()
{
	BMenu*	aMenu;

	while  ( (aMenu = mMBar->SubmenuAt(0)) != NULL ) {
		mMBar->RemoveItem(aMenu);
		delete aMenu;
	}
}
//------------------------------------------------------------------------------
void	TLocaleWin::LanguageChanged()
{
	SetWinTitle();
	// メニュー再構築
	DestroyMenu();
	CreateMenu();
}
//------------------------------------------------------------------------------
void	TLocaleWin::MessageReceived(BMessage* oMsg)
{
	switch ( oMsg->what ) {
	case B_LANGUAGE_CHANGED:
		LanguageChanged();
		break;
	default:
		SUPER::MessageReceived(oMsg);
	}
}
//------------------------------------------------------------------------------
bool	TLocaleWin::QuitRequested()
{
	BMessage	aSendMsg(B_QUIT_REQUESTED);

	be_app_messenger.SendMessage(&aSendMsg);
	return true;
}
//------------------------------------------------------------------------------
void	TLocaleWin::SetWinTitle()
{
	SetTitle(_T("Locale Change Sample"));
}
//==============================================================================
int		main(int oArgC, char* oArgV[])
{
	TLocaleApp	aApp;

	aApp.Run();
	return 0;
}
//==============================================================================
